"use strict";function invariant(t,i){if(!t)throw new Error(i)}function withDefault(t,i){return void 0!==t?t:i}Object.defineProperty(exports,"__esModule",{value:!0});var classCallCheck=function(t,i){if(!(t instanceof i))throw new TypeError("Cannot call a class as a function")},createClass=function(){function t(t,i){for(var e=0;e<i.length;e++){var n=i[e];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(i,e,n){return e&&t(i.prototype,e),n&&t(i,n),i}}(),_extends=Object.assign||function(t){for(var i=1;i<arguments.length;i++){var e=arguments[i];for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&(t[n]=e[n])}return t},Spring=function(){function t(){var i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};classCallCheck(this,t),this._listeners=[],this._currentAnimationStep=0,this._currentTime=0,this._springTime=0,this._currentValue=0,this._currentVelocity=0,this._isAnimating=!1,this._oscillationVelocityPairs=[],this._config={fromValue:withDefault(i.fromValue,0),toValue:withDefault(i.toValue,0),stiffness:withDefault(i.stiffness,100),damping:withDefault(i.damping,10),mass:withDefault(i.mass,1),initialVelocity:withDefault(i.initialVelocity,0),overshootClamping:withDefault(i.overshootClamping,!1),allowsOverdamping:withDefault(i.allowsOverdamping,!1),restVelocityThreshold:withDefault(i.restVelocityThreshold,.001),restDisplacementThreshold:withDefault(i.restDisplacementThreshold,.001)}}return createClass(t,[{key:"start",value:function(){var t=this,i=this._config,e=i.fromValue,n=i.toValue,s=i.initialVelocity;e===n&&0===s||(this._reset(),this._isAnimating=!0,this._currentAnimationStep||(this._currentAnimationStep=requestAnimationFrame(function(i){t._notifyListeners("onStart"),t._step(i)})))}},{key:"stop",value:function(){this._isAnimating&&(this._isAnimating=!1,this._notifyListeners("onStop"),this._currentAnimationStep&&(cancelAnimationFrame(this._currentAnimationStep),this._currentAnimationStep=0))}},{key:"updateConfig",value:function(t){var i={fromValue:this._currentValue,initialVelocity:this._currentVelocity};this._config=_extends({},this._config,i,t),this._reset()}},{key:"onStart",value:function(t){return this._listeners.push({onStart:t}),this}},{key:"onUpdate",value:function(t){return this._listeners.push({onUpdate:t}),this}},{key:"onStop",value:function(t){return this._listeners.push({onStop:t}),this}},{key:"removeListener",value:function(t){return this._listeners=this._listeners.reduce(function(i,e){return-1!==Object.values(e).indexOf(t)||i.push(e),i},[]),this}},{key:"removeAllListeners",value:function(){return this._listeners=[],this}},{key:"_reset",value:function(){this._currentTime=0,this._springTime=0,this._currentValue=this._config.fromValue,this._currentVelocity=this._config.initialVelocity}},{key:"_notifyListeners",value:function(t){var i=this;this._listeners.forEach(function(e){var n=e[t];"function"==typeof n&&n(i)})}},{key:"_step",value:function(t){var i=this;this._currentTime||(this._currentTime=t);var e=t-this._currentTime;this._evaluateSpring(e),this._currentTime=t,this._isAnimating&&(this._currentAnimationStep=requestAnimationFrame(function(t){return i._step(t)}))}},{key:"_evaluateSpring",value:function(i){i>t.MAX_DELTA_TIME_MS&&(i=t.MAX_DELTA_TIME_MS),this._springTime+=i;var e=this._config.damping,n=this._config.mass,s=this._config.stiffness,r=this._config.fromValue,a=this._config.toValue,o=-this._config.initialVelocity;invariant(n>0,"Mass value must be greater than 0"),invariant(s>0,"Stiffness value must be greater than 0"),invariant(e>0,"Damping value must be greater than 0");var u=e/(2*Math.sqrt(s*n)),h=Math.sqrt(s/n)/1e3,l=h*Math.sqrt(1-u*u),c=h*Math.sqrt(u*u-1),f=a-r;u>1&&!this._config.allowsOverdamping&&(u=1);var _=0,p=0,g=this._springTime;if(u<1){var m=Math.exp(-u*h*g);_=a-m*((o+u*h*f)/l*Math.sin(l*g)+f*Math.cos(l*g)),p=u*h*m*(Math.sin(l*g)*(o+u*h*f)/l+f*Math.cos(l*g))-m*(Math.cos(l*g)*(o+u*h*f)-l*f*Math.sin(l*g))}else if(1===u){var v=Math.exp(-h*g);_=a-v*(f+(o+h*f)*g),p=v*(o*(g*h-1)+g*f*(h*h))}else{var y=Math.exp(-u*h*g);_=a-y*((o+u*h*f)*Math.sinh(c*g)+c*f*Math.cosh(c*g))/c,p=y*u*h*(Math.sinh(c*g)*(o+u*h*f)+f*c*Math.cosh(c*g))/c-y*(c*Math.cosh(c*g)*(o+u*h*f)+c*c*f*Math.sinh(c*g))/c}if(this._currentValue=_,this._currentVelocity=p,this._notifyListeners("onUpdate"),this._isAnimating)return this._isSpringOvershooting()||this._isSpringAtRest()?(0!==s&&(this._currentValue=a,this._currentVelocity=0,this._notifyListeners("onUpdate")),void this.stop()):void 0}},{key:"_isSpringOvershooting",value:function(){var t=this._config,i=t.stiffness,e=t.fromValue,n=t.toValue,s=!1;return t.overshootClamping&&0!==i&&(s=e<n?this._currentValue>n:this._currentValue<n),s}},{key:"_isSpringAtRest",value:function(){var t=this._config,i=t.stiffness,e=t.toValue,n=t.restDisplacementThreshold,s=t.restVelocityThreshold,r=Math.abs(this._currentVelocity)<=s;return 0!==i&&Math.abs(e-this._currentValue)<=n&&r}},{key:"currentValue",get:function(){return this._currentValue}},{key:"currentVelocity",get:function(){return this._currentVelocity}},{key:"isAtRest",get:function(){return this._isSpringAtRest()}},{key:"isAnimating",get:function(){return this._isAnimating}}]),t}();Spring.MAX_DELTA_TIME_MS=1/60*1e3*4,exports.Spring=Spring;
//# sourceMappingURL=wobble.cjs.js.map
