function invariant(t,i){if(!t)throw new Error(i)}function withDefault(t,i){return void 0!==t?t:i}var _extends=Object.assign||function(t){for(var i=1;i<arguments.length;i++){var e=arguments[i];for(var s in e)Object.prototype.hasOwnProperty.call(e,s)&&(t[s]=e[s])}return t};class Spring{constructor(t={}){this._listeners=[],this._currentAnimationStep=0,this._currentTime=0,this._springTime=0,this._currentValue=0,this._currentVelocity=0,this._isAnimating=!1,this._oscillationVelocityPairs=[],this._config={fromValue:withDefault(t.fromValue,0),toValue:withDefault(t.toValue,0),stiffness:withDefault(t.stiffness,100),damping:withDefault(t.damping,10),mass:withDefault(t.mass,1),initialVelocity:withDefault(t.initialVelocity,0),overshootClamping:withDefault(t.overshootClamping,!1),allowsOverdamping:withDefault(t.allowsOverdamping,!1),restVelocityThreshold:withDefault(t.restVelocityThreshold,.001),restDisplacementThreshold:withDefault(t.restDisplacementThreshold,.001)}}start(){const{fromValue:t,toValue:i,initialVelocity:e}=this._config;t===i&&0===e||(this._reset(),this._isAnimating=!0,this._currentAnimationStep||(this._currentAnimationStep=requestAnimationFrame(t=>{this._notifyListeners("onStart"),this._step(t)})))}stop(){this._isAnimating&&(this._isAnimating=!1,this._notifyListeners("onStop"),this._currentAnimationStep&&(cancelAnimationFrame(this._currentAnimationStep),this._currentAnimationStep=0))}get currentValue(){return this._currentValue}get currentVelocity(){return this._currentVelocity}get isAtRest(){return this._isSpringAtRest()}get isAnimating(){return this._isAnimating}updateConfig(t){const i={fromValue:this._currentValue,initialVelocity:this._currentVelocity};this._config=_extends({},this._config,i,t),this._reset()}onStart(t){return this._listeners.push({onStart:t}),this}onUpdate(t){return this._listeners.push({onUpdate:t}),this}onStop(t){return this._listeners.push({onStop:t}),this}removeListener(t){return this._listeners=this._listeners.reduce((i,e)=>(-1!==Object.values(e).indexOf(t)||i.push(e),i),[]),this}removeAllListeners(){return this._listeners=[],this}_reset(){this._currentTime=0,this._springTime=0,this._currentValue=this._config.fromValue,this._currentVelocity=this._config.initialVelocity}_notifyListeners(t){this._listeners.forEach(i=>{const e=i[t];"function"==typeof e&&e(this)})}_step(t){this._currentTime||(this._currentTime=t);const i=t-this._currentTime;this._evaluateSpring(i),this._currentTime=t,this._isAnimating&&(this._currentAnimationStep=requestAnimationFrame(t=>this._step(t)))}_evaluateSpring(t){t>Spring.MAX_DELTA_TIME_MS&&(t=Spring.MAX_DELTA_TIME_MS),this._springTime+=t;const i=this._config.damping,e=this._config.mass,s=this._config.stiffness,n=this._config.fromValue,r=this._config.toValue,h=-this._config.initialVelocity;invariant(e>0,"Mass value must be greater than 0"),invariant(s>0,"Stiffness value must be greater than 0"),invariant(i>0,"Damping value must be greater than 0");let a=i/(2*Math.sqrt(s*e));const o=Math.sqrt(s/e)/1e3,l=o*Math.sqrt(1-a*a),c=o*Math.sqrt(a*a-1),u=r-n;a>1&&!this._config.allowsOverdamping&&(a=1);let _=0,f=0;const g=this._springTime;if(a<1){const t=Math.exp(-a*o*g);_=r-t*((h+a*o*u)/l*Math.sin(l*g)+u*Math.cos(l*g)),f=a*o*t*(Math.sin(l*g)*(h+a*o*u)/l+u*Math.cos(l*g))-t*(Math.cos(l*g)*(h+a*o*u)-l*u*Math.sin(l*g))}else if(1===a){const t=Math.exp(-o*g);_=r-t*(u+(h+o*u)*g),f=t*(h*(g*o-1)+g*u*(o*o))}else{const t=Math.exp(-a*o*g);_=r-t*((h+a*o*u)*Math.sinh(c*g)+c*u*Math.cosh(c*g))/c,f=t*a*o*(Math.sinh(c*g)*(h+a*o*u)+u*c*Math.cosh(c*g))/c-t*(c*Math.cosh(c*g)*(h+a*o*u)+c*c*u*Math.sinh(c*g))/c}if(this._currentValue=_,this._currentVelocity=f,this._notifyListeners("onUpdate"),this._isAnimating)return this._isSpringOvershooting()||this._isSpringAtRest()?(0!==s&&(this._currentValue=r,this._currentVelocity=0,this._notifyListeners("onUpdate")),void this.stop()):void 0}_isSpringOvershooting(){const{stiffness:t,fromValue:i,toValue:e,overshootClamping:s}=this._config;let n=!1;return s&&0!==t&&(n=i<e?this._currentValue>e:this._currentValue<e),n}_isSpringAtRest(){const{stiffness:t,toValue:i,restDisplacementThreshold:e,restVelocityThreshold:s}=this._config,n=Math.abs(this._currentVelocity)<=s;return 0!==t&&Math.abs(i-this._currentValue)<=e&&n}}Spring.MAX_DELTA_TIME_MS=1/60*1e3*4;export{Spring};
//# sourceMappingURL=wobble.es.js.map
